/* Net.c generated by valac, the Vala compiler
 * generated from Net.vala, do not modify */

/* Meiga - Lightweight and easy to use web file server for your desktop
 *
 * Copyright (C) 2009 Igalia, S.L.
 *
 * Authors:
 *
 * Igalia, S.L. <info@igalia.com>
 * Enrique Ocaña González <eocanha@igalia.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_NET (net_get_type ())
#define NET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NET, Net))
#define NET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NET, NetClass))
#define IS_NET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NET))
#define IS_NET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NET))
#define NET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NET, NetClass))

typedef struct _Net Net;
typedef struct _NetClass NetClass;
typedef struct _NetPrivate NetPrivate;

#define TYPE_LOG (log_get_type ())
#define LOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOG, Log))
#define LOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOG, LogClass))
#define IS_LOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOG))
#define IS_LOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOG))
#define LOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOG, LogClass))

typedef struct _Log Log;
typedef struct _LogClass LogClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _Net {
	GObject parent_instance;
	NetPrivate * priv;
};

struct _NetClass {
	GObjectClass parent_class;
};

struct _NetPrivate {
	GThread* worker;
	GStaticRecMutex __lock_worker;
	char* _external_ip;
	char* _internal_ip;
	gint _port;
	char* _url;
	gint _previous_redirection_type;
	gint _redirection_type;
	gint _redirection_status;
	char* _ssh_host;
	char* _ssh_port;
	char* _ssh_user;
	char* _ssh_password;
	char* _display;
	Log* _logger;
};


static gpointer net_parent_class = NULL;

GType net_get_type (void);
GType log_get_type (void);
#define NET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NET, NetPrivate))
enum  {
	NET_DUMMY_PROPERTY,
	NET_PORT,
	NET_URL,
	NET_REDIRECTION_TYPE,
	NET_REDIRECTION_STATUS,
	NET_SSH_HOST,
	NET_SSH_PORT,
	NET_SSH_USER,
	NET_SSH_PASSWORD,
	NET_DISPLAY,
	NET_LOGGER
};
#define NET_REDIRECTION_TYPE_NONE 0
#define NET_REDIRECTION_TYPE_UPNP 1
#define NET_REDIRECTION_TYPE_SSH 2
#define NET_REDIRECTION_STATUS_NONE 0
#define NET_REDIRECTION_STATUS_PENDING 1
#define NET_REDIRECTION_STATUS_DONE 2
#define NET_REDIRECTION_STATUS_ERROR 3
void net_set_port (Net* self, gint value);
static void net_set_url (Net* self, const char* value);
void net_set_logger (Net* self, Log* value);
void net_set_ssh_host (Net* self, const char* value);
void net_set_ssh_user (Net* self, const char* value);
void net_set_display (Net* self, const char* value);
static void* net_forward_none_start (Net* self);
Net* net_new (void);
Net* net_construct (GType object_type);
void log_log (Log* self, const char* msg);
static void net_log (Net* self, const char* msg);
static void net_forward_stop (Net* self);
static void net_forward_start (Net* self);
gboolean net_forward_reload (Net* self);
gint net_get_redirection_type (Net* self);
static void* net_forward_upnp_start (Net* self);
static void* _net_forward_upnp_start_gthread_func (gpointer self);
static void* net_forward_ssh_start (Net* self);
static void* _net_forward_ssh_start_gthread_func (gpointer self);
void net_forward_upnp_stop (Net* self);
void net_forward_ssh_stop (Net* self);
gint net_get_port (Net* self);
static void net_set_internal_ip (Net* self, const char* value);
static void net_set_external_ip (Net* self, const char* value);
void net_set_redirection_status (Net* self, gint value);
static gboolean _lambda5_ (Net* self);
static gboolean __lambda5__gsource_func (gpointer self);
static gboolean _lambda6_ (Net* self);
static gboolean __lambda6__gsource_func (gpointer self);
gint net_get_redirection_status (Net* self);
static char* net_get_internal_ip (Net* self);
static char* net_get_external_ip (Net* self);
static gboolean _lambda3_ (Net* self);
static gboolean __lambda3__gsource_func (gpointer self);
static gboolean _lambda7_ (Net* self);
static gboolean __lambda7__gsource_func (gpointer self);
static gboolean _lambda8_ (Net* self);
static gboolean __lambda8__gsource_func (gpointer self);
char* net_get_ssh_host (Net* self);
char* net_get_ssh_user (Net* self);
char* net_get_ssh_password (Net* self);
char* net_get_ssh_port (Net* self);
char* net_get_display (Net* self);
static gboolean _lambda4_ (Net* self);
static gboolean __lambda4__gsource_func (gpointer self);
char* net_get_url (Net* self);
static gboolean _net_forward_reload_gsource_func (gpointer self);
void net_set_redirection_type (Net* self, gint value);
void net_set_ssh_port (Net* self, const char* value);
void net_set_ssh_password (Net* self, const char* value);
static Log* net_get_logger (Net* self);
static void net_finalize (GObject* obj);
static void net_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void net_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



Net* net_construct (GType object_type) {
	Net * self;
	self = (Net*) g_object_new (object_type, NULL);
	net_set_port (self, 8001);
	net_set_url (self, NULL);
	net_set_logger (self, NULL);
	self->priv->_previous_redirection_type = NET_REDIRECTION_TYPE_NONE;
	self->priv->_redirection_type = NET_REDIRECTION_TYPE_NONE;
	self->priv->_redirection_status = NET_REDIRECTION_STATUS_NONE;
	net_set_ssh_host (self, "");
	net_set_ssh_user (self, "");
	net_set_display (self, "");
	net_forward_none_start (self);
	return self;
}


Net* net_new (void) {
	return net_construct (TYPE_NET);
}


static void net_log (Net* self, const char* msg) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (msg != NULL);
	if (self->priv->_logger != NULL) {
		log_log (self->priv->_logger, msg);
	}
}


gboolean net_forward_reload (Net* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->_redirection_type != self->priv->_previous_redirection_type) {
		net_forward_stop (self);
		net_forward_start (self);
	}
	result = FALSE;
	return result;
}


static void* _net_forward_upnp_start_gthread_func (gpointer self) {
	return net_forward_upnp_start (self);
}


static void* _net_forward_ssh_start_gthread_func (gpointer self) {
	return net_forward_ssh_start (self);
}


static void net_forward_start (Net* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	switch (net_get_redirection_type (self)) {
		case NET_REDIRECTION_TYPE_NONE:
		{
			net_forward_none_start (self);
			break;
		}
		case NET_REDIRECTION_TYPE_UPNP:
		{
			{
				GThread* _tmp0_;
				_tmp0_ = g_thread_create (_net_forward_upnp_start_gthread_func, self, TRUE, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_SPAWN_ERROR) {
						goto __catch5_g_spawn_error;
					}
					if (_inner_error_->domain == G_THREAD_ERROR) {
						goto __catch5_g_thread_error;
					}
					goto __finally5;
				}
				self->priv->worker = _tmp0_;
			}
			goto __finally5;
			__catch5_g_spawn_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
					net_log (self, _ ("Error spawning UPNP redirector process"));
					_g_error_free0 (e);
				}
			}
			goto __finally5;
			__catch5_g_thread_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
					net_log (self, _ ("Error creating thread for UPNP redirector process"));
					_g_error_free0 (e);
				}
			}
			__finally5:
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			break;
		}
		case NET_REDIRECTION_TYPE_SSH:
		{
			{
				GThread* _tmp1_;
				_tmp1_ = g_thread_create (_net_forward_ssh_start_gthread_func, self, TRUE, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_SPAWN_ERROR) {
						goto __catch6_g_spawn_error;
					}
					if (_inner_error_->domain == G_THREAD_ERROR) {
						goto __catch6_g_thread_error;
					}
					goto __finally6;
				}
				self->priv->worker = _tmp1_;
			}
			goto __finally6;
			__catch6_g_spawn_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
					net_log (self, _ ("Error spawning UPNP redirector process"));
					_g_error_free0 (e);
				}
			}
			goto __finally6;
			__catch6_g_thread_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
					net_log (self, _ ("Error creating thread for UPNP redirector process"));
					_g_error_free0 (e);
				}
			}
			__finally6:
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			break;
		}
	}
}


static void net_forward_stop (Net* self) {
	g_return_if_fail (self != NULL);
	switch (self->priv->_previous_redirection_type) {
		case NET_REDIRECTION_TYPE_UPNP:
		{
			net_forward_upnp_stop (self);
			break;
		}
		case NET_REDIRECTION_TYPE_SSH:
		{
			net_forward_ssh_stop (self);
			break;
		}
	}
}


static char* string_chomp (const char* self) {
	char* result;
	char* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	_result_ = g_strdup (self);
	g_strchomp (_result_);
	result = _result_;
	return result;
}


static void* net_forward_none_start (Net* self) {
	void* result;
	GError * _inner_error_;
	char* internal_ip;
	char* url;
	char* txtout;
	char* txterr;
	gint _result_ = 0;
	char* _tmp5_;
	gboolean _tmp4_;
	char* _tmp3_ = NULL;
	char* _tmp2_;
	gboolean _tmp1_;
	char* _tmp0_ = NULL;
	char* _tmp9_;
	g_return_val_if_fail (self != NULL, NULL);
	_inner_error_ = NULL;
	internal_ip = NULL;
	url = NULL;
	txtout = NULL;
	txterr = NULL;
	_tmp4_ = (_tmp1_ = g_spawn_command_line_sync (BINDIR "/fwlocalip", &_tmp0_, &_tmp3_, &_result_, &_inner_error_), txtout = (_tmp2_ = _tmp0_, _g_free0 (txtout), _tmp2_), _tmp1_);
	txterr = (_tmp5_ = _tmp3_, _g_free0 (txterr), _tmp5_);
	_tmp4_;
	if (_inner_error_ != NULL) {
		_g_free0 (internal_ip);
		_g_free0 (url);
		_g_free0 (txtout);
		_g_free0 (txterr);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	if (_result_ == 0) {
		char* _tmp6_;
		char* _tmp7_;
		internal_ip = (_tmp6_ = string_chomp (txtout), _g_free0 (internal_ip), _tmp6_);
		net_log (self, _tmp7_ = g_strdup_printf (_ ("Found internal IP: %s"), internal_ip));
		_g_free0 (_tmp7_);
	} else {
		char* _tmp8_;
		net_log (self, _ ("Local IP not found"));
		internal_ip = (_tmp8_ = g_strdup ("127.0.0.1"), _g_free0 (internal_ip), _tmp8_);
	}
	url = (_tmp9_ = g_strdup_printf ("http://%s:%d", internal_ip, net_get_port (self)), _g_free0 (url), _tmp9_);
	net_set_internal_ip (self, internal_ip);
	net_set_external_ip (self, internal_ip);
	net_set_url (self, url);
	net_set_redirection_status (self, NET_REDIRECTION_STATUS_NONE);
	result = NULL;
	_g_free0 (internal_ip);
	_g_free0 (url);
	_g_free0 (txtout);
	_g_free0 (txterr);
	return result;
}


static gboolean _lambda5_ (Net* self) {
	gboolean result;
	net_set_redirection_status (self, NET_REDIRECTION_STATUS_PENDING);
	result = FALSE;
	return result;
}


static gboolean __lambda5__gsource_func (gpointer self) {
	return _lambda5_ (self);
}


static gboolean _lambda6_ (Net* self) {
	gboolean result;
	net_set_redirection_status (self, NET_REDIRECTION_STATUS_ERROR);
	result = FALSE;
	return result;
}


static gboolean __lambda6__gsource_func (gpointer self) {
	return _lambda6_ (self);
}


static void* net_forward_upnp_start (Net* self) {
	void* result;
	GError * _inner_error_;
	char* internal_ip;
	char* external_ip;
	char* url;
	char* txtout;
	char* txterr;
	gint _result_ = 0;
	gint status = 0;
	char* _tmp5_;
	gboolean _tmp4_;
	char* _tmp3_ = NULL;
	char* _tmp2_;
	gboolean _tmp1_;
	char* _tmp0_ = NULL;
	char* _tmp9_;
	char* _tmp37_;
	char* _tmp38_;
	char* _tmp39_;
	char* _tmp40_;
	g_return_val_if_fail (self != NULL, NULL);
	_inner_error_ = NULL;
	internal_ip = NULL;
	external_ip = NULL;
	url = NULL;
	txtout = NULL;
	txterr = NULL;
	status = NET_REDIRECTION_STATUS_PENDING;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __lambda5__gsource_func, g_object_ref (self), g_object_unref);
	_tmp4_ = (_tmp1_ = g_spawn_command_line_sync (BINDIR "/fwlocalip", &_tmp0_, &_tmp3_, &_result_, &_inner_error_), txtout = (_tmp2_ = _tmp0_, _g_free0 (txtout), _tmp2_), _tmp1_);
	txterr = (_tmp5_ = _tmp3_, _g_free0 (txterr), _tmp5_);
	_tmp4_;
	if (_inner_error_ != NULL) {
		_g_free0 (internal_ip);
		_g_free0 (external_ip);
		_g_free0 (url);
		_g_free0 (txtout);
		_g_free0 (txterr);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	if (_result_ == 0) {
		char* _tmp6_;
		char* _tmp7_;
		internal_ip = (_tmp6_ = string_chomp (txtout), _g_free0 (internal_ip), _tmp6_);
		net_log (self, _tmp7_ = g_strdup_printf (_ ("Found internal IP: %s"), internal_ip));
		_g_free0 (_tmp7_);
	} else {
		char* _tmp8_;
		net_log (self, _ ("Local IP not found"));
		internal_ip = (_tmp8_ = g_strdup ("127.0.0.1"), _g_free0 (internal_ip), _tmp8_);
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __lambda6__gsource_func, g_object_ref (self), g_object_unref);
		result = NULL;
		_g_free0 (internal_ip);
		_g_free0 (external_ip);
		_g_free0 (url);
		_g_free0 (txtout);
		_g_free0 (txterr);
		return result;
	}
	external_ip = (_tmp9_ = g_strdup (internal_ip), _g_free0 (external_ip), _tmp9_);
	if (strcmp (internal_ip, "127.0.0.1") != 0) {
		char* _tmp15_;
		gboolean _tmp14_;
		char* _tmp13_ = NULL;
		char* _tmp12_;
		gboolean _tmp11_;
		char* _tmp10_ = NULL;
		char* _tmp16_;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		_tmp14_ = (_tmp11_ = g_spawn_command_line_sync (BINDIR "/fwupnp -i", &_tmp10_, &_tmp13_, &_result_, &_inner_error_), txtout = (_tmp12_ = _tmp10_, _g_free0 (txtout), _tmp12_), _tmp11_);
		txterr = (_tmp15_ = _tmp13_, _g_free0 (txterr), _tmp15_);
		_tmp14_;
		if (_inner_error_ != NULL) {
			_g_free0 (internal_ip);
			_g_free0 (external_ip);
			_g_free0 (url);
			_g_free0 (txtout);
			_g_free0 (txterr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		txtout = (_tmp16_ = string_chomp (txtout), _g_free0 (txtout), _tmp16_);
		if (_result_ == 0) {
			_tmp18_ = strcmp (txtout, "") != 0;
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			_tmp17_ = strcmp (txtout, "(null)") != 0;
		} else {
			_tmp17_ = FALSE;
		}
		if (_tmp17_) {
			char* _tmp19_;
			char* _tmp20_;
			char* _tmp28_;
			gboolean _tmp27_;
			char* _tmp26_ = NULL;
			char* _tmp25_;
			gboolean _tmp24_;
			char* _tmp23_ = NULL;
			char* _tmp22_;
			char* _tmp21_;
			external_ip = (_tmp19_ = g_strdup (txtout), _g_free0 (external_ip), _tmp19_);
			net_log (self, _tmp20_ = g_strdup_printf (_ ("Found external IP: %s"), external_ip));
			_g_free0 (_tmp20_);
			_tmp27_ = (_tmp24_ = g_spawn_command_line_sync (_tmp22_ = g_strconcat (BINDIR, _tmp21_ = g_strdup_printf ("/fwupnp -q %d", net_get_port (self)), NULL), &_tmp23_, &_tmp26_, &_result_, &_inner_error_), txtout = (_tmp25_ = _tmp23_, _g_free0 (txtout), _tmp25_), _tmp24_);
			txterr = (_tmp28_ = _tmp26_, _g_free0 (txterr), _tmp28_);
			_tmp27_;
			if (_inner_error_ != NULL) {
				_g_free0 (internal_ip);
				_g_free0 (external_ip);
				_g_free0 (url);
				_g_free0 (txtout);
				_g_free0 (txterr);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_g_free0 (_tmp22_);
			_g_free0 (_tmp21_);
			if (_result_ != 0) {
				char* _tmp36_;
				gboolean _tmp35_;
				char* _tmp34_ = NULL;
				char* _tmp33_;
				gboolean _tmp32_;
				char* _tmp31_ = NULL;
				char* _tmp30_;
				char* _tmp29_;
				net_log (self, _ ("Creating redirection"));
				_tmp35_ = (_tmp32_ = g_spawn_command_line_sync (_tmp30_ = g_strconcat (BINDIR, _tmp29_ = g_strdup_printf ("/fwupnp -r %d %d %s %s %d", net_get_port (self), net_get_port (self), internal_ip, "Meiga", 0), NULL), &_tmp31_, &_tmp34_, &_result_, &_inner_error_), txtout = (_tmp33_ = _tmp31_, _g_free0 (txtout), _tmp33_), _tmp32_);
				txterr = (_tmp36_ = _tmp34_, _g_free0 (txterr), _tmp36_);
				_tmp35_;
				if (_inner_error_ != NULL) {
					_g_free0 (internal_ip);
					_g_free0 (external_ip);
					_g_free0 (url);
					_g_free0 (txtout);
					_g_free0 (txterr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
				_g_free0 (_tmp30_);
				_g_free0 (_tmp29_);
				if (_result_ == 0) {
					net_log (self, _ ("Redirection performed"));
					status = NET_REDIRECTION_STATUS_DONE;
				}
			} else {
				net_log (self, _ ("Redirection already present"));
				status = NET_REDIRECTION_STATUS_DONE;
			}
		} else {
			net_log (self, _ ("External IP not found. Check that your router has UPnP enabled and working"));
			status = NET_REDIRECTION_STATUS_ERROR;
		}
	}
	url = (_tmp37_ = g_strdup_printf ("http://%s:%d", external_ip, net_get_port (self)), _g_free0 (url), _tmp37_);
	internal_ip = (_tmp38_ = g_strdup (internal_ip), _g_free0 (internal_ip), _tmp38_);
	external_ip = (_tmp39_ = g_strdup (external_ip), _g_free0 (external_ip), _tmp39_);
	url = (_tmp40_ = g_strdup (url), _g_free0 (url), _tmp40_);
	net_set_redirection_status (self, status);
	result = NULL;
	_g_free0 (internal_ip);
	_g_free0 (external_ip);
	_g_free0 (url);
	_g_free0 (txtout);
	_g_free0 (txterr);
	return result;
}


static gboolean _lambda3_ (Net* self) {
	gboolean result;
	net_set_redirection_status (self, NET_REDIRECTION_STATUS_NONE);
	result = FALSE;
	return result;
}


static gboolean __lambda3__gsource_func (gpointer self) {
	return _lambda3_ (self);
}


void net_forward_upnp_stop (Net* self) {
	GError * _inner_error_;
	char* txtout;
	char* txterr;
	gint _result_ = 0;
	gint status = 0;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	txtout = NULL;
	txterr = NULL;
	status = net_get_redirection_status (self);
	if (status == NET_REDIRECTION_STATUS_DONE) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = status == NET_REDIRECTION_STATUS_PENDING;
	}
	if (_tmp0_) {
		char* _tmp2_;
		char* _tmp1_;
		gboolean _tmp3_;
		if ((_tmp3_ = _vala_strcmp0 (_tmp1_ = net_get_internal_ip (self), _tmp2_ = net_get_external_ip (self)) != 0, _g_free0 (_tmp2_), _g_free0 (_tmp1_), _tmp3_)) {
			char* _tmp11_;
			gboolean _tmp10_;
			char* _tmp9_ = NULL;
			char* _tmp8_;
			gboolean _tmp7_;
			char* _tmp6_ = NULL;
			char* _tmp5_;
			char* _tmp4_;
			_tmp10_ = (_tmp7_ = g_spawn_command_line_sync (_tmp5_ = g_strconcat (BINDIR, _tmp4_ = g_strdup_printf ("/fwupnp -d %d", net_get_port (self)), NULL), &_tmp6_, &_tmp9_, &_result_, &_inner_error_), txtout = (_tmp8_ = _tmp6_, _g_free0 (txtout), _tmp8_), _tmp7_);
			txterr = (_tmp11_ = _tmp9_, _g_free0 (txterr), _tmp11_);
			_tmp10_;
			if (_inner_error_ != NULL) {
				_g_free0 (txtout);
				_g_free0 (txterr);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_g_free0 (_tmp5_);
			_g_free0 (_tmp4_);
			if (_result_ == 0) {
				net_log (self, _ ("Redirection removed"));
			} else {
				net_log (self, _ ("Unable to remove redirection"));
			}
		}
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __lambda3__gsource_func, g_object_ref (self), g_object_unref);
	_g_free0 (txtout);
	_g_free0 (txterr);
}


static gboolean _lambda7_ (Net* self) {
	gboolean result;
	net_set_redirection_status (self, NET_REDIRECTION_STATUS_PENDING);
	result = FALSE;
	return result;
}


static gboolean __lambda7__gsource_func (gpointer self) {
	return _lambda7_ (self);
}


static gboolean _lambda8_ (Net* self) {
	gboolean result;
	net_set_redirection_status (self, NET_REDIRECTION_STATUS_ERROR);
	result = FALSE;
	return result;
}


static gboolean __lambda8__gsource_func (gpointer self) {
	return _lambda8_ (self);
}


static void* net_forward_ssh_start (Net* self) {
	void* result;
	GError * _inner_error_;
	char* tmp_internal_ip;
	char* tmp_external_ip;
	char* tmp_url;
	char* txtout;
	char* txterr;
	gboolean bresult = FALSE;
	gint _result_ = 0;
	gint status = 0;
	char* _tmp5_;
	gboolean _tmp4_;
	char* _tmp3_ = NULL;
	char* _tmp2_;
	gboolean _tmp1_;
	char* _tmp0_ = NULL;
	char* _tmp9_;
	char* _tmp25_;
	g_return_val_if_fail (self != NULL, NULL);
	_inner_error_ = NULL;
	tmp_internal_ip = NULL;
	tmp_external_ip = NULL;
	tmp_url = NULL;
	txtout = NULL;
	txterr = NULL;
	status = NET_REDIRECTION_STATUS_PENDING;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __lambda7__gsource_func, g_object_ref (self), g_object_unref);
	_tmp4_ = (_tmp1_ = g_spawn_command_line_sync (BINDIR "/fwlocalip", &_tmp0_, &_tmp3_, &_result_, &_inner_error_), txtout = (_tmp2_ = _tmp0_, _g_free0 (txtout), _tmp2_), _tmp1_);
	txterr = (_tmp5_ = _tmp3_, _g_free0 (txterr), _tmp5_);
	_tmp4_;
	if (_inner_error_ != NULL) {
		_g_free0 (tmp_internal_ip);
		_g_free0 (tmp_external_ip);
		_g_free0 (tmp_url);
		_g_free0 (txtout);
		_g_free0 (txterr);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	if (_result_ == 0) {
		char* _tmp6_;
		char* _tmp7_;
		tmp_internal_ip = (_tmp6_ = string_chomp (txtout), _g_free0 (tmp_internal_ip), _tmp6_);
		net_log (self, _tmp7_ = g_strdup_printf (_ ("Found internal IP: %s"), tmp_internal_ip));
		_g_free0 (_tmp7_);
	} else {
		char* _tmp8_;
		net_log (self, _ ("Local IP not found"));
		tmp_internal_ip = (_tmp8_ = g_strdup ("127.0.0.1"), _g_free0 (tmp_internal_ip), _tmp8_);
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __lambda8__gsource_func, g_object_ref (self), g_object_unref);
	}
	tmp_external_ip = (_tmp9_ = g_strdup (tmp_internal_ip), _g_free0 (tmp_external_ip), _tmp9_);
	if (strcmp (tmp_internal_ip, "127.0.0.1") != 0) {
		char* sshcmd;
		gint sshcmd_argv_size;
		gint sshcmd_argv_length1;
		char** sshcmd_argv;
		char* _tmp10_;
		char* _tmp13_;
		char* _tmp12_;
		char* _tmp11_;
		char* _tmp14_;
		char** _tmp16_;
		char** _tmp15_;
		char* _tmp17_;
		char* _tmp18_;
		char* _tmp19_;
		char* _tmp20_;
		sshcmd = g_strdup (BINDIR "/fwssh -r ");
		sshcmd_argv = (sshcmd_argv_length1 = 0, NULL);
		tmp_external_ip = (_tmp10_ = net_get_ssh_host (self), _g_free0 (tmp_external_ip), _tmp10_);
		sshcmd = (_tmp13_ = g_strconcat (sshcmd, _tmp12_ = g_strdup_printf ("%s %d %s %d", _tmp11_ = net_get_ssh_host (self), net_get_port (self), tmp_internal_ip, net_get_port (self)), NULL), _g_free0 (sshcmd), _tmp13_);
		_g_free0 (_tmp12_);
		_g_free0 (_tmp11_);
		net_log (self, _tmp14_ = g_strdup_printf (_ ("Using external IP: %s"), tmp_external_ip));
		_g_free0 (_tmp14_);
		net_log (self, _ ("Creating SSH tunnel"));
		sshcmd_argv = (_tmp16_ = _tmp15_ = g_strsplit_set (sshcmd, " ", 0), sshcmd_argv = (_vala_array_free (sshcmd_argv, sshcmd_argv_length1, (GDestroyNotify) g_free), NULL), sshcmd_argv_length1 = _vala_array_length (_tmp15_), sshcmd_argv_size = sshcmd_argv_length1, _tmp16_);
		g_setenv ("SSH_USER", _tmp17_ = net_get_ssh_user (self), TRUE);
		_g_free0 (_tmp17_);
		g_setenv ("SSH_PASSWORD", _tmp18_ = net_get_ssh_password (self), TRUE);
		_g_free0 (_tmp18_);
		g_setenv ("SSH_PORT", _tmp19_ = net_get_ssh_port (self), TRUE);
		_g_free0 (_tmp19_);
		g_setenv ("DISPLAY", _tmp20_ = net_get_display (self), TRUE);
		_g_free0 (_tmp20_);
		{
			gboolean _tmp21_;
			gboolean _tmp22_ = FALSE;
			_tmp21_ = g_spawn_sync (NULL, sshcmd_argv, NULL, G_SPAWN_STDOUT_TO_DEV_NULL | G_SPAWN_STDERR_TO_DEV_NULL, NULL, NULL, NULL, NULL, &_result_, &_inner_error_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_SPAWN_ERROR) {
					goto __catch7_g_spawn_error;
				}
				goto __finally7;
			}
			bresult = _tmp21_;
			if (bresult) {
				_tmp22_ = _result_ == 0;
			} else {
				_tmp22_ = FALSE;
			}
			if (_tmp22_) {
				net_log (self, _ ("Redirection performed"));
				status = NET_REDIRECTION_STATUS_DONE;
			} else {
				char* _tmp23_;
				net_log (self, _ ("Error creating SSH tunnel. Check config parameters and password."));
				tmp_external_ip = (_tmp23_ = g_strdup (tmp_internal_ip), _g_free0 (tmp_external_ip), _tmp23_);
				status = NET_REDIRECTION_STATUS_ERROR;
			}
		}
		goto __finally7;
		__catch7_g_spawn_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp24_;
				net_log (self, _ ("Error spawning SSH redirector process"));
				tmp_external_ip = (_tmp24_ = g_strdup (tmp_internal_ip), _g_free0 (tmp_external_ip), _tmp24_);
				status = NET_REDIRECTION_STATUS_ERROR;
				_g_error_free0 (e);
			}
		}
		__finally7:
		if (_inner_error_ != NULL) {
			_g_free0 (sshcmd);
			sshcmd_argv = (_vala_array_free (sshcmd_argv, sshcmd_argv_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (tmp_internal_ip);
			_g_free0 (tmp_external_ip);
			_g_free0 (tmp_url);
			_g_free0 (txtout);
			_g_free0 (txterr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_free0 (sshcmd);
		sshcmd_argv = (_vala_array_free (sshcmd_argv, sshcmd_argv_length1, (GDestroyNotify) g_free), NULL);
	}
	tmp_url = (_tmp25_ = g_strdup_printf ("http://%s:%d", tmp_external_ip, net_get_port (self)), _g_free0 (tmp_url), _tmp25_);
	net_set_internal_ip (self, tmp_internal_ip);
	net_set_external_ip (self, tmp_external_ip);
	net_set_url (self, tmp_url);
	net_set_redirection_status (self, status);
	result = NULL;
	_g_free0 (tmp_internal_ip);
	_g_free0 (tmp_external_ip);
	_g_free0 (tmp_url);
	_g_free0 (txtout);
	_g_free0 (txterr);
	return result;
}


static gboolean _lambda4_ (Net* self) {
	gboolean result;
	net_set_redirection_status (self, NET_REDIRECTION_STATUS_NONE);
	result = FALSE;
	return result;
}


static gboolean __lambda4__gsource_func (gpointer self) {
	return _lambda4_ (self);
}


void net_forward_ssh_stop (Net* self) {
	GError * _inner_error_;
	char* txtout;
	char* txterr;
	gint _result_ = 0;
	gint status = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	txtout = NULL;
	txterr = NULL;
	status = net_get_redirection_status (self);
	if (status == NET_REDIRECTION_STATUS_DONE) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = status == NET_REDIRECTION_STATUS_PENDING;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = status == NET_REDIRECTION_STATUS_ERROR;
	}
	if (_tmp0_) {
		char* _tmp9_;
		gboolean _tmp8_;
		char* _tmp7_ = NULL;
		char* _tmp6_;
		gboolean _tmp5_;
		char* _tmp4_ = NULL;
		char* _tmp3_;
		char* _tmp2_;
		_tmp8_ = (_tmp5_ = g_spawn_command_line_sync (_tmp3_ = g_strconcat (BINDIR, _tmp2_ = g_strdup_printf ("/fwssh -d %d", net_get_port (self)), NULL), &_tmp4_, &_tmp7_, &_result_, &_inner_error_), txtout = (_tmp6_ = _tmp4_, _g_free0 (txtout), _tmp6_), _tmp5_);
		txterr = (_tmp9_ = _tmp7_, _g_free0 (txterr), _tmp9_);
		_tmp8_;
		if (_inner_error_ != NULL) {
			_g_free0 (txtout);
			_g_free0 (txterr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_free0 (_tmp3_);
		_g_free0 (_tmp2_);
		if (_result_ == 0) {
			net_log (self, _ ("Redirection removed"));
		} else {
			net_log (self, _ ("Unable to remove redirection"));
		}
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __lambda4__gsource_func, g_object_ref (self), g_object_unref);
	_g_free0 (txtout);
	_g_free0 (txterr);
}


static char* net_get_external_ip (Net* self) {
	char* result;
	char* r;
	g_return_val_if_fail (self != NULL, NULL);
	r = NULL;
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp0_;
		r = (_tmp0_ = g_strdup (self->priv->_external_ip), _g_free0 (r), _tmp0_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


static void net_set_external_ip (Net* self, const char* value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp1_;
		self->priv->_external_ip = (_tmp1_ = g_strdup (value), _g_free0 (self->priv->_external_ip), _tmp1_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
}


static char* net_get_internal_ip (Net* self) {
	char* result;
	char* r;
	g_return_val_if_fail (self != NULL, NULL);
	r = NULL;
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp0_;
		r = (_tmp0_ = g_strdup (self->priv->_internal_ip), _g_free0 (r), _tmp0_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


static void net_set_internal_ip (Net* self, const char* value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp1_;
		self->priv->_internal_ip = (_tmp1_ = g_strdup (value), _g_free0 (self->priv->_internal_ip), _tmp1_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
}


gint net_get_port (Net* self) {
	gint result;
	gint r = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		r = self->priv->_port;
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


void net_set_port (Net* self, gint value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		self->priv->_port = value;
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	g_object_notify ((GObject *) self, "port");
}


char* net_get_url (Net* self) {
	char* result;
	char* r;
	g_return_val_if_fail (self != NULL, NULL);
	r = NULL;
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		const char* _tmp0_;
		char* _tmp1_;
		_tmp0_ = NULL;
		if (self->priv->_url == NULL) {
			_tmp0_ = "";
		} else {
			_tmp0_ = self->priv->_url;
		}
		r = (_tmp1_ = g_strdup (_tmp0_), _g_free0 (r), _tmp1_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


static void net_set_url (Net* self, const char* value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp2_;
		self->priv->_url = (_tmp2_ = g_strdup (value), _g_free0 (self->priv->_url), _tmp2_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	g_object_notify ((GObject *) self, "url");
}


gint net_get_redirection_type (Net* self) {
	gint result;
	gint r = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		r = self->priv->_redirection_type;
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


static gboolean _net_forward_reload_gsource_func (gpointer self) {
	return net_forward_reload (self);
}


void net_set_redirection_type (Net* self, gint value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		if (self->priv->_redirection_status == NET_REDIRECTION_STATUS_PENDING) {
			return;
		}
		self->priv->_previous_redirection_type = self->priv->_redirection_type;
		self->priv->_redirection_type = value;
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _net_forward_reload_gsource_func, g_object_ref (self), g_object_unref);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	g_object_notify ((GObject *) self, "redirection-type");
}


gint net_get_redirection_status (Net* self) {
	gint result;
	gint r = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		r = self->priv->_redirection_status;
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


void net_set_redirection_status (Net* self, gint value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		self->priv->_redirection_status = value;
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	g_object_notify ((GObject *) self, "redirection-status");
}


char* net_get_ssh_host (Net* self) {
	char* result;
	char* r;
	g_return_val_if_fail (self != NULL, NULL);
	r = NULL;
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp0_;
		r = (_tmp0_ = g_strdup (self->priv->_ssh_host), _g_free0 (r), _tmp0_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


void net_set_ssh_host (Net* self, const char* value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp1_;
		self->priv->_ssh_host = (_tmp1_ = g_strdup (value), _g_free0 (self->priv->_ssh_host), _tmp1_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	g_object_notify ((GObject *) self, "ssh-host");
}


char* net_get_ssh_port (Net* self) {
	char* result;
	char* r;
	g_return_val_if_fail (self != NULL, NULL);
	r = NULL;
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp0_;
		r = (_tmp0_ = g_strdup (self->priv->_ssh_port), _g_free0 (r), _tmp0_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


void net_set_ssh_port (Net* self, const char* value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp1_;
		self->priv->_ssh_port = (_tmp1_ = g_strdup (value), _g_free0 (self->priv->_ssh_port), _tmp1_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	g_object_notify ((GObject *) self, "ssh-port");
}


char* net_get_ssh_user (Net* self) {
	char* result;
	char* r;
	g_return_val_if_fail (self != NULL, NULL);
	r = NULL;
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp0_;
		r = (_tmp0_ = g_strdup (self->priv->_ssh_user), _g_free0 (r), _tmp0_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


void net_set_ssh_user (Net* self, const char* value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp1_;
		self->priv->_ssh_user = (_tmp1_ = g_strdup (value), _g_free0 (self->priv->_ssh_user), _tmp1_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	g_object_notify ((GObject *) self, "ssh-user");
}


char* net_get_ssh_password (Net* self) {
	char* result;
	char* r;
	g_return_val_if_fail (self != NULL, NULL);
	r = NULL;
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp0_;
		r = (_tmp0_ = g_strdup (self->priv->_ssh_password), _g_free0 (r), _tmp0_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


void net_set_ssh_password (Net* self, const char* value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp1_;
		self->priv->_ssh_password = (_tmp1_ = g_strdup (value), _g_free0 (self->priv->_ssh_password), _tmp1_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	g_object_notify ((GObject *) self, "ssh-password");
}


char* net_get_display (Net* self) {
	char* result;
	char* r;
	g_return_val_if_fail (self != NULL, NULL);
	r = NULL;
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp0_;
		r = (_tmp0_ = g_strdup (self->priv->_display), _g_free0 (r), _tmp0_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


void net_set_display (Net* self, const char* value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		char* _tmp1_;
		self->priv->_display = (_tmp1_ = g_strdup (value), _g_free0 (self->priv->_display), _tmp1_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	g_object_notify ((GObject *) self, "display");
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Log* net_get_logger (Net* self) {
	Log* result;
	Log* r;
	g_return_val_if_fail (self != NULL, NULL);
	r = NULL;
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		Log* _tmp0_;
		r = (_tmp0_ = _g_object_ref0 (self->priv->_logger), _g_object_unref0 (r), _tmp0_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	result = r;
	return result;
}


void net_set_logger (Net* self, Log* value) {
	g_return_if_fail (self != NULL);
	g_static_rec_mutex_lock (&self->priv->__lock_worker);
	{
		Log* _tmp1_;
		self->priv->_logger = (_tmp1_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_logger), _tmp1_);
	}
	g_static_rec_mutex_unlock (&self->priv->__lock_worker);
	g_object_notify ((GObject *) self, "logger");
}


static void net_class_init (NetClass * klass) {
	net_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NetPrivate));
	G_OBJECT_CLASS (klass)->get_property = net_get_property;
	G_OBJECT_CLASS (klass)->set_property = net_set_property;
	G_OBJECT_CLASS (klass)->finalize = net_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NET_PORT, g_param_spec_int ("port", "port", "port", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NET_URL, g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NET_REDIRECTION_TYPE, g_param_spec_int ("redirection-type", "redirection-type", "redirection-type", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NET_REDIRECTION_STATUS, g_param_spec_int ("redirection-status", "redirection-status", "redirection-status", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NET_SSH_HOST, g_param_spec_string ("ssh-host", "ssh-host", "ssh-host", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NET_SSH_PORT, g_param_spec_string ("ssh-port", "ssh-port", "ssh-port", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NET_SSH_USER, g_param_spec_string ("ssh-user", "ssh-user", "ssh-user", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NET_SSH_PASSWORD, g_param_spec_string ("ssh-password", "ssh-password", "ssh-password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NET_DISPLAY, g_param_spec_string ("display", "display", "display", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NET_LOGGER, g_param_spec_object ("logger", "logger", "logger", TYPE_LOG, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
}


static void net_instance_init (Net * self) {
	self->priv = NET_GET_PRIVATE (self);
	g_static_rec_mutex_init (&self->priv->__lock_worker);
	self->priv->worker = NULL;
	self->priv->_url = NULL;
	self->priv->_display = NULL;
}


static void net_finalize (GObject* obj) {
	Net * self;
	self = NET (obj);
	g_static_rec_mutex_free (&self->priv->__lock_worker);
	_g_free0 (self->priv->_external_ip);
	_g_free0 (self->priv->_internal_ip);
	_g_free0 (self->priv->_url);
	_g_free0 (self->priv->_ssh_host);
	_g_free0 (self->priv->_ssh_port);
	_g_free0 (self->priv->_ssh_user);
	_g_free0 (self->priv->_ssh_password);
	_g_free0 (self->priv->_display);
	_g_object_unref0 (self->priv->_logger);
	G_OBJECT_CLASS (net_parent_class)->finalize (obj);
}


GType net_get_type (void) {
	static GType net_type_id = 0;
	if (net_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (NetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) net_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Net), 0, (GInstanceInitFunc) net_instance_init, NULL };
		net_type_id = g_type_register_static (G_TYPE_OBJECT, "Net", &g_define_type_info, 0);
	}
	return net_type_id;
}


static void net_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Net * self;
	self = NET (object);
	switch (property_id) {
		case NET_PORT:
		g_value_set_int (value, net_get_port (self));
		break;
		case NET_URL:
		g_value_set_string (value, net_get_url (self));
		break;
		case NET_REDIRECTION_TYPE:
		g_value_set_int (value, net_get_redirection_type (self));
		break;
		case NET_REDIRECTION_STATUS:
		g_value_set_int (value, net_get_redirection_status (self));
		break;
		case NET_SSH_HOST:
		g_value_set_string (value, net_get_ssh_host (self));
		break;
		case NET_SSH_PORT:
		g_value_set_string (value, net_get_ssh_port (self));
		break;
		case NET_SSH_USER:
		g_value_set_string (value, net_get_ssh_user (self));
		break;
		case NET_SSH_PASSWORD:
		g_value_set_string (value, net_get_ssh_password (self));
		break;
		case NET_DISPLAY:
		g_value_set_string (value, net_get_display (self));
		break;
		case NET_LOGGER:
		g_value_set_object (value, net_get_logger (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void net_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Net * self;
	self = NET (object);
	switch (property_id) {
		case NET_PORT:
		net_set_port (self, g_value_get_int (value));
		break;
		case NET_URL:
		net_set_url (self, g_value_get_string (value));
		break;
		case NET_REDIRECTION_TYPE:
		net_set_redirection_type (self, g_value_get_int (value));
		break;
		case NET_REDIRECTION_STATUS:
		net_set_redirection_status (self, g_value_get_int (value));
		break;
		case NET_SSH_HOST:
		net_set_ssh_host (self, g_value_get_string (value));
		break;
		case NET_SSH_PORT:
		net_set_ssh_port (self, g_value_get_string (value));
		break;
		case NET_SSH_USER:
		net_set_ssh_user (self, g_value_get_string (value));
		break;
		case NET_SSH_PASSWORD:
		net_set_ssh_password (self, g_value_get_string (value));
		break;
		case NET_DISPLAY:
		net_set_display (self, g_value_get_string (value));
		break;
		case NET_LOGGER:
		net_set_logger (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




